// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- // 
// C++ Source Code File Name: testprog.cpp
// Compiler Used: MSVC40, egcs-2.90.29, HP CPP 10.24
// Produced By: Doug Gaer   
// File Creation Date: 03/25/2000
// Date Last Modified: 05/09/2000
// Copyright (c) 2000 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ------------- Program Description and Details ------------- // 
// ----------------------------------------------------------- // 
/*
The VBD and VBS C++ classes are copyright (c) 1997 and 2000 by 
Douglas M. Gaer. All those who put this code or its derivatives 
in a commercial product MUST mention this copyright in their
documentation for users of the products in which this code or its 
derivative classes are used. Otherwise, you have the freedom to 
redistribute verbatim copies of this source code, adapt it to your 
specific needs, or improve the code and release your improvements 
to the public provided that the modified files carry prominent 
notices stating that you changed the files and the date of any
change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

Simple test program demonstrating the basic operation of the
vbThread class using condition variables.
*/
// ----------------------------------------------------------- //   
#include <iostream.h>
#include "vbthread.h"
#include "vbcond.h"
#include "vbmutex.h"

// For safe condition variable usage, must use a boolean predicate and 
// a mutex with the condition.
int conditionMet = 0;
vbCondition cond;
vbMutex mutex;

class SimpleThread : public vbThread
{
private: // Base class interface
  void *ThreadEntryRoutine(vbThread_t *thread);
};

void *SimpleThread::ThreadEntryRoutine(vbThread_t *thread)
// Thread's entry function
{
  mutex.MutexLock();
  
  while (!conditionMet) {
    cout << "Thread blocked" << endl;
    cond.ConditionWait(&mutex);
  }

  mutex.MutexUnlock();

  return 0;
}

int main(int argc, char **argv)
{
  const int NUM_THREADS = 5;
  SimpleThread t;
  vbThread_t *thread[NUM_THREADS];

  cout << "Create " << NUM_THREADS << " threads" << endl;
  int i;
  for(i = 0; i < NUM_THREADS; i++) thread[i] = t.CreateThread(); 

  t.sSleep(1); // Serialize the threads 
  mutex.MutexLock();
  
  // The condition has occured. Set the flag and wake up any waiters
  conditionMet = 1;
  cout << "Wake up all waiters..." << endl;
  cond.ConditionBroadcast();
  
  mutex.MutexUnlock();

  
  cout << "Wait for threads before exiting" << endl;
  for(i = 0; i < NUM_THREADS; ++i) t.JoinThread(thread[i]);

  return 0;
}
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //


  

