######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program
# C/C++ Compiler Used: HP C++ A.10.09  compiled for HP-UX 10.20 
# Produced By: Doug Gaer
# File Creation Date: 04/28/2000
# Date Last Modified: 05/17/2000
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#       v  -- Echo compilation
#       g  -- Enable debugging
#	+w -- Turn on all warnings
# --------------------------------------------------------------- 
SHELL = /bin/sh

# Define a name for the executable
PROJECT = server

# Setup additional paths for includes and source code
THELPERS_PATH = ../../src/
THRPOOL_PATH = ../../src/
THRAPIW_PATH = ../../src/
VBCOND_PATH = ../../src/
VBMUTEX_PATH = ../../src/
VBSEMA_PATH = ../../src/
VBTHREAD_PATH = ../../src/
VTHREADT_PATH = ../../src/

# Setup path to the DCE thread library
DCE_INSTALL_PATH = /opt/dce
DCE_INCLUDE_PATH = $(DCE_INSTALL_PATH)/include
DCE_LIB_PATH = $(DCE_INSTALL_PATH)/lib

ADD_INC_PATHS = -I../../include -I$(DCE_INCLUDE_PATH)

# Setup define macros
DEFMACS = -D__UNIX__ -D__POSIX__ -D__HPUX__ -D__HPUX10__

# Define macros for compiler and linker
CC = cc
CPP = CC
LINKER = ld

# Define compiler and linker flags macros
COMPILE_FLAGS= +DAportable $(ADD_INC_PATHS) $(DEFMACS)

COMPILE_ONLY = -c
OUTPUT = -o
LINKER_FLAGS = 
LIBRARIES = $(DCE_LIB_PATH)/libcma.a 

# Build dependency rules
# ===============================================================
THELPERS_DEP = ../../include/thrtypes.h ../../include/thelpers.h

THRAPIW_DEP = ../../include/thrtypes.h ../../include/thrapiw.h \
	../../include/vthreadt.h ../../include/vbthread.h \
	../../include/thrpool.h ../../include/vbmutex.h \
	../../include/vbcond.h ../../include/thelpers.h

THRPOOL_DEP = ../../include/thrtypes.h ../../include/thrpool.h \
	../../include/vthreadt.h

VBCOND_DEP = ../../include/thrtypes.h ../../include/vbcond.h \
	../../include/thelpers.h ../../include/vbmutex.h

VBMUTEX_DEP = ../../include/thrtypes.h ../../include/vbmutex.h \
	../../include/thelpers.h

VBSEMA_DEP = ../../include/thrtypes.h ../../include/vbsema.h \
	../../include/thelpers.h

VBTHREAD_DEP = ../../include/thrtypes.h  ../../include/vbthread.h \
	../../include/vthreadt.h ../../include/thrapiw.h \
	../../include/thrpool.h

VTHREADT_DEP = ../../include/thrtypes.h ../../include/vthreadt.h \
	../../include/vbthread.h ../../include/thrpool.h \
	../../include/vbcond.h ../../include/vbmutex.h \
	../../include/thelpers.h

VBSOCKET_DEP = vbsocket.h vbstypes.h

HTTPSERV_DEP = vbsocket.h httpserv.h \
	../../include/thrtypes.h ../../include/thelpers.h \
	../../include/vbthread.h ../../include/vthreadt.h \
	../../include/thrpool.h ../../include/vbmutex.h \
	../../include/vbcond.h ../../include/vbsema.h


SERVER_DEP = vbsocket.h httpserv.h \
	 ../../include/thrtypes.h ../../include/thelpers.h \
	../../include/vbthread.h ../../include/vthreadt.h \
	../../include/thrpool.h ../../include/vbmutex.h \
	../../include/vbcond.h ../../include/vbsema.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT)

thrapiw.o:	$(THRAPIW_PATH)thrapiw.cpp $(THRAPIW_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(THRAPIW_PATH)thrapiw.cpp

thelpers.o:	$(THELPERS_PATH)thelpers.cpp $(THELPERS_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(THELPERS_PATH)thelpers.cpp

thrpool.o:	$(THRPOOL_PATH)thrpool.cpp $(THRPOOL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(THRPOOL_PATH)thrpool.cpp

vbthread.o:	$(VBTHREAD_PATH)vbthread.cpp $(VBTHREAD_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBTHREAD_PATH)vbthread.cpp

vthreadt.o:	$(VTHREADT_PATH)vthreadt.cpp $(VTHREADT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VTHREADT_PATH)vthreadt.cpp

vbmutex.o:	$(VBMUTEX_PATH)vbmutex.cpp $(VBMUTEX_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBMUTEX_PATH)vbmutex.cpp

vbcond.o:	$(VBCOND_PATH)vbcond.cpp $(VBCOND_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBCOND_PATH)vbcond.cpp

vbsema.o:	$(VBSEMA_PATH)vbsema.cpp $(VBSEMA_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBSEMA_PATH)vbsema.cpp

vbsocket.o:	vbsocket.cpp $(VBSOCKET_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) vbsocket.cpp

httpserv.o:	httpserv.cpp $(HTTPSERV_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) httpserv.cpp

server.o:	server.cpp $(SERVER_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) server.cpp

# Make the executable
OBJECTS = vbthread.o vbmutex.o thrpool.o vthreadt.o vbcond.o \
	vbsema.o thrapiw.o thelpers.o vbsocket.o httpserv.o \
	server.o

$(PROJECT):	$(OBJECTS)
	$(CPP) $(COMPILE_FLAGS) $(OBJECTS) $(LIBRARIES) \
	$(OUTPUT) $(PROJECT) $(LINKER_FLAGS)
# ===============================================================

# Remove object files and the executable after running make 
# ===============================================================
clean:
	echo Removing all OBJECT files from working directory...
	rm -f *.o 

	echo Removing EXECUTABLE file from working directory...
	rm -f $(PROJECT)
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################
