// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- // 
// C++ Source Code File Name: vbsocket.cpp
// C++ Compiler Used: MSVC40, HP CPP 10.24, egcs-2.90.29 
// Produced By: Doug Gaer   
// File Creation Date: 04/28/2000
// Date Last Modified: 05/17/2000
// Copyright (c) 2000 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ------------- Program Description and Details ------------- // 
// ----------------------------------------------------------- // 
/*
The VBS C++ classes are copyright (c) 2000, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

A very simple multi-threaded HTTP server built using the
vbThread library.
*/
// ----------------------------------------------------------- // 
#include "httpserv.h"
#include "string.h"

int vbHTTPServer::InitHTTPServer(int port, int max_connections)
// Initialize the HTTP server. Returns a non-zero value if any
// errors ocurr.
{
  address_family = AF_INET;
  socket_type = SOCK_STREAM;
  protocol_family = IPPROTO_TCP;
  port_number = port;
  
  // Put the server information into the server structure.
  sin.sin_family = address_family;
  sin.sin_addr.s_addr = INADDR_ANY; // Use my IP address

  // The port must be put into network byte order.
  sin.sin_port = htons(port_number);
  
  // Create a TCP/IP stream socket
  if(InitSocket() < 0) return 1;

  // Bind the name to the socket
  if(Bind() < 0) {
    Close();
    return 1;
  }
    
  // Listen for connections with a specifed backlog
  if(Listen(max_connections) < 0) {
    Close();
    return 1;
  }

  return 0;
}

int vbHTTPServer::RemotePortNumber(int &port)
// Pass back the port number actually set by the system
// in the "port" variable.
{
  port = GetRemotePortNumber();
  return 0;
}

int vbHTTPServer::HostName(char *hs)
{
  if(GetHostName(hs) < 0) {
    return 1;
  }
  return 0;
}

int vbHTTPServer::RemoteHostName(char *hs)
{
  if(GetRemoteHostName(hs) < 0) {
    return 1;
  }
  return 0;
}

void vbHTTPServer::GetClientInfo(char *client_name, int &r_port)
// Get the client's host name and port number. NOTE: This
// function assumes that a block of memory equal to the
// vbsMAX_NAME_LEN constant has already been allocated.
{
  int rv = GetRemoteHostName(client_name);
  if(rv < 0) {
    char *unc = "UNKNOWN";
    for(int i = 0; i < vbsMAX_NAME_LEN; i++) client_name[i] = '\0';
    strcpy(client_name, unc);
  }
  RemotePortNumber(r_port);
}


void *vbHTTPServer::ThreadEntryRoutine(vbThread_t *thread)
// Client thread.
{
  const int rxbuf = 1024;
  char request[rxbuf];
  int rv = RawRemoteRead(request, rxbuf);
  request[rv] = 0; // Null terminate the buffer

  // At this point we need to parse the client request and process it.
  // For simplicity sake these operations have been omitted.
  // ... (parsing operation)
  // ... (processing operation)

  // Simply send a test page (with a header) back to the client.
  const char *test_page = "HTTP/1.0 200 OK\r\nServer: vbThread\r\nConnection: \
close\r\n\r\n<HTML>\n<HEAD>\n<TITLE> vbThread Test Page </TITLE>\n</HEAD>\
<BODY><CENTER><H1>vbThread Test Page</H1></CENTER><HR><PRE>Response from the \
multi-threaded HTTP server</PRE><HR><CENTER>End of document</CENTER>\n</BODY>\
\n</HTML>";

  RemoteSend(test_page, strlen(test_page));
  return 0;
}

void vbHTTPServer::ThreadExitRoutine(vbThread_t *thread)
// Thread exit function used to close the client thread.
{
  CloseRemoteSocket();
}

void vbHTTPServer::ThreadCleanupHandler(vbThread_t *thread)
// Thread cleanup handler used in the event that the thread is
// canceled.
{
  CloseRemoteSocket();
}
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
