// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: vsheader.h
// C++ Compiler Used: MSVC40, HP CPP 10.24, egcs-2.90.29 
// Produced By: Doug Gaer   
// File Creation Date: 09/20/1999
// Date Last Modified: 05/26/2000
// Copyright (c) 2000 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBS C++ classes are copyright (c) 2000, by Douglas M. Gaer.
All those who put this code or its derivatives in a commercial
product MUST mention this copyright in their documentation for
users of the products in which this code or its derivative
classes are used. Otherwise, you have the freedom to redistribute
verbatim copies of this source code, adapt it to your specific
needs, or improve the code and release your improvements to the
public provided that the modified files carry prominent notices
stating that you changed the files and the date of any change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

This include file contains cross-platform type definitions and
enumerations used throughout the VB socket library.
*/
// ----------------------------------------------------------- //   
#ifndef __VBSOCKET_TYPES_HPP__
#define __VBSOCKET_TYPES_HPP__

// --------------------------------------------------------------
// Platform specific include files
// --------------------------------------------------------------
#if defined (__WIN32__)
#include <winsock.h>

#elif defined (__UNIX__)
#include <unistd.h>     // UNIX standard function definitions 
#include <sys/types.h>  // Type definitions
#include <netdb.h>      // Net DB structures
#include <arpa/inet.h>  // Inet functions
#include <netinet/in.h> // Structures defined by the internet system
#include <sys/socket.h> // Definitions related to sockets

#else
#error You must define a target platform:\n __WIN32__ or __UNIX__
#endif

// --------------------------------------------------------------

// --------------------------------------------------------------
// Type definitions
// --------------------------------------------------------------
typedef int vbsAddressFamily;  // Address family to which a socket belongs
typedef int vbsProtocolFamily; // Protocol family to which a socket belongs
typedef int vbsSocketType;     // Type used to ID sockets
typedef int vbsPortNumber;     // Data type used for port numbers
typedef sockaddr_in vbsSocketAddress; // Sock Internet address
typedef servent vbsServent;           // Service name and protocol information
typedef hostent vbsHostNameInfo;      // Host name information
// --------------------------------------------------------------

// --------------------------------------------------------------
// Constants 
// --------------------------------------------------------------
const unsigned vbsBUF_SIZE     =  1024; // Fixed string buffer length
const unsigned vbsMAX_NAME_LEN =  255;  // Maximum string name length
// --------------------------------------------------------------

// --------------------------------------------------------------
// Enumerations
// --------------------------------------------------------------
enum vbsSocketError {
  // vbsSocket exception codes
  vbSOCKET_NO_ERROR = 0, // No errors reported
  vbSOCKET_INVALID_CODE, // Invalid file error code

  vbSOCKET_ACCEPT_ERROR,        // Error accepting remote socket
  vbSOCKET_BIND_ERROR,          // Could not bind socket
  vbSOCKET_CONNECT_ERROR,       // Could not connect socket
  vbSOCKET_HOSTNAME_ERROR,      // Could not resolve hostname
  vbSOCKET_INIT_ERROR,          // Initialization error
  vbSOCKET_LISTEN_ERROR,        // Listen error
  vbSOCKET_PROTOCOL_ERROR,      // Unknown protocol requested
  vbSOCKET_RECEIVE_ERROR,       // Receive error
  vbSOCKET_SERVICE_ERROR,       // Unknown service requested
  vbSOCKET_TRANSMIT_ERROR,      // Transmit error
  vbSOCKET_WINSOCKINIT_ERROR,   // Could not inititalize Winsock (WIN32 only)
  vbSOCKET_WINSOCKVERSION_ERROR // Winsock version not supported (WIN32 only)
};

enum vbsServices {
  // Common port assignments
  vbSOCKET_FTP_PORT        = 21,  // tcp ftp port
  vbSOCKET_TELNET_PORT     = 23,  // tcp telent port
  vbSOCKET_SMTP_PORT       = 25,  // tcp simple mail transfer protocol port
  vbSOCKET_TIME_PORT       = 37,  // tcp time server
  vbSOCKET_NAME_PORT       = 42,  // tcp name server
  vbSOCKET_NAMESERVER_PORT = 53,  // tcp domain name server
  vbSOCKET_FINGER_PORT     = 79,  // tcp finger port
  vbSOCKET_HTTP_PORT       = 80,  // tcp http port
  vbSOCKET_POP_PORT        = 109, // tcp postoffice protocol
  vbSOCKET_POP2_PORT       = 109, // tcp postoffice protocol
  vbSOCKET_POP3_PORT       = 110, // tcp postoffice protocol
  vbSOCKET_NNTP_PORT       = 119, // tcp network news transfer protocol

  // vbsSocket default port assignment
  vbsDEFAULT_PORT = 3000 // Value used if no port is assigned
};

enum vbsServerTypes {
  vbSOCKET_STREAM_SERVER,
  vbSOCKET_DATAGRAM_SERVER,
  vbSOCKET_SERIAL_PORT_SERVER,
  vbSOCKET_HTTP_SERVER,
  vbSOCKET_LOCAL_FILE_SYSTEM
};

enum vbClientTypes {
  vbSOCKET_STREAM_CLIENT,
  vbSOCKET_DATAGRAM_CLIENT,
  vbSOCKET_HTTP_CLIENT,
  vbSOCKET_SERIAL_PORT_CLIENT
};
// --------------------------------------------------------------

#endif // __VBSOCKET_TYPES_HPP__
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
