// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- // 
// C++ Source Code File Name: testprog.cpp
// Compiler Used: MSVC40, egcs-2.90.29, HP CPP 10.24
// Produced By: Doug Gaer   
// File Creation Date: 03/25/2000
// Date Last Modified: 05/10/2000
// Copyright (c) 2000 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ------------- Program Description and Details ------------- // 
// ----------------------------------------------------------- // 
/*
The VBD and VBS C++ classes are copyright (c) 1997 and 2000 by 
Douglas M. Gaer. All those who put this code or its derivatives 
in a commercial product MUST mention this copyright in their
documentation for users of the products in which this code or its 
derivative classes are used. Otherwise, you have the freedom to 
redistribute verbatim copies of this source code, adapt it to your 
specific needs, or improve the code and release your improvements 
to the public provided that the modified files carry prominent 
notices stating that you changed the files and the date of any
change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

Simple test program demonstrating the vbThread status and error
message functions for vbThread_t types.
*/
// ----------------------------------------------------------- //   
#include <iostream.h>
#include <stdlib.h>
#include "vbthread.h"

// Constants
const int THREAD_EXIT_CODE = 15; // Arbitrary exit code value

void PrintThreadStatus(vbThread_t *thread)
{
  cout << "Thread OID: " << (int)thread->GetObjectID() << endl;
  cout << "Thread CID: " << (int)thread->GetClassID() << endl;
  cout << thread->ThreadExceptionMessage() << endl;
  cout << thread->ThreadPriorityMessage() << endl;
  cout << thread->ThreadStateMessage() << endl;
  cout << thread->ThreadTypeMessage() << endl;
  if(thread->GetStackSize() > (vbStackSizeType)0)
    cout << "Stack size: " << (int)thread->GetStackSize() << endl;
  if(thread->GetThreadExitCode() == (vbThreadExitCode)THREAD_EXIT_CODE)
    cout << "Exit code: " << (int)thread->GetThreadExitCode() << endl;
}

class SimpleThread : public vbThread
{
public:
  SimpleThread() { cid = 1500; oid = 0; }
  ~SimpleThread() { }
  
private: // Base class interface
  void *ThreadEntryRoutine(vbThread_t *thread);
  void ThreadExitRoutine(vbThread_t *thread);

private:
  vbThreadObjectID oid;
  vbThreadClassID cid;
};

void *SimpleThread::ThreadEntryRoutine(vbThread_t *thread)
{
  thread->SetClassID(cid);
  thread->SetObjectID(oid++);
  PrintThreadStatus(thread);  
  sSleep(1);
  return (void *)THREAD_EXIT_CODE;
}

void SimpleThread::ThreadExitRoutine(vbThread_t *thread)
{
  cout << endl;
  PrintThreadStatus(thread);  
  cout << endl;
}

// Main thread of execution
int main()
{
  SimpleThread t;

  const int NUM_THREADS = 10;
  vbThread_t *thread[NUM_THREADS];

  int i;
  for(i = 0; i < NUM_THREADS; i++) {
    thread[i] = t.CreateThread();

    // Check for any errors created during thread creataion
    if(thread[i]->GetThreadError() != 0) {
      cout << thread[i]->ThreadExceptionMessage() << endl;
    }

    t.sSleep(3);
  }

  // Wait for all the threads to finish before exiting
  for(i = 0; i < NUM_THREADS; i++) t.JoinThread(thread[i]);
  

  // Cleanup all the vbThread_t pointers
  for(i = 0; i < NUM_THREADS; i++) {
    int rv = t.DestroyThread(thread[i]);
    if(rv != 0) {
      cout << "Error destroying thread!" << endl;
    }
  }

  return 0; // Exit the process
}
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //


  

