#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program  
# C/C++ Compiler Used: Microsoft Visual C/C++ 4.2 
# Produced By: Doug Gaer
# File Creation Date: 03/25/2000
# Date Last Modified: 05/09/2000
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#	Zi -- Enable debugging
#       W3 -- Turn on warnings 
#       MT -- Link with LIBCMT.LIB
# --------------------------------------------------------------- 
# Define a name for the executable
PROJECT = testprog

# Setup additional paths for includes and source code
THELPERS_PATH = ../../src/
THRPOOL_PATH = ../../src/
THRAPIW_PATH = ../../src/
VBCOND_PATH = ../../src/
VBMUTEX_PATH = ../../src/
VBSEMA_PATH = ../../src/
VBTHREAD_PATH = ../../src/
VTHREADT_PATH = ../../src/

ADD_INC_PATHS = -I../../include

# Setup define macros
DEFMACS = /D__WIN32__ /D"_X86_" /D__HAS__BEGINTHREADEX__

# Define macros for compiler and linker
CC = cl
CPP = cl
LINKER = link

# Define compiler and linker flags macros
COMPILE_FLAGS= /Zi /W3 /MT $(ADD_INC_PATHS) $(DEFMACS)
COMPILE_ONLY = /c
LINKER_FLAGS = 

# Build dependency rules
# ===============================================================
THELPERS_DEP = ../../include/thrtypes.h ../../include/thelpers.h

THRAPIW_DEP = ../../include/thrtypes.h ../../include/thrapiw.h \
	../../include/vthreadt.h ../../include/vbthread.h \
	../../include/thrpool.h ../../include/vbmutex.h \
	../../include/vbcond.h ../../include/thelpers.h

THRPOOL_DEP = ../../include/thrtypes.h ../../include/thrpool.h \
	../../include/vthreadt.h

VBCOND_DEP = ../../include/thrtypes.h ../../include/vbcond.h \
	../../include/thelpers.h ../../include/vbmutex.h

VBMUTEX_DEP = ../../include/thrtypes.h ../../include/vbmutex.h \
	../../include/thelpers.h

VBSEMA_DEP = ../../include/thrtypes.h ../../include/vbsema.h \
	../../include/thelpers.h

VBTHREAD_DEP = ../../include/thrtypes.h  ../../include/vbthread.h \
	../../include/vthreadt.h ../../include/thrapiw.h \
	../../include/thrpool.h

VTHREADT_DEP = ../../include/thrtypes.h ../../include/vthreadt.h \
	../../include/vbthread.h ../../include/thrpool.h \
	../../include/vbcond.h ../../include/vbmutex.h \
	../../include/thelpers.h

TESTPROG_DEP = ../../include/thrtypes.h ../../include/thelpers.h \
	../../include/vbthread.h ../../include/vthreadt.h \
	../../include/thrpool.h ../../include/vbmutex.h \
	../../include/vbcond.h ../../include/vbsema.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT).exe

thrapiw.obj:	$(THRAPIW_PATH)thrapiw.cpp $(THRAPIW_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(THRAPIW_PATH)thrapiw.cpp

thelpers.obj:	$(THELPERS_PATH)thelpers.cpp $(THELPERS_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(THELPERS_PATH)thelpers.cpp

thrpool.obj:	$(THRPOOL_PATH)thrpool.cpp $(THRPOOL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(THRPOOL_PATH)thrpool.cpp

vbthread.obj:	$(VBTHREAD_PATH)vbthread.cpp $(VBTHREAD_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBTHREAD_PATH)vbthread.cpp

vthreadt.obj:	$(VTHREADT_PATH)vthreadt.cpp $(VTHREADT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VTHREADT_PATH)vthreadt.cpp

vbmutex.obj:	$(VBMUTEX_PATH)vbmutex.cpp $(VBMUTEX_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBMUTEX_PATH)vbmutex.cpp

vbcond.obj:	$(VBCOND_PATH)vbcond.cpp $(VBCOND_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBCOND_PATH)vbcond.cpp

vbsema.obj:	$(VBSEMA_PATH)vbsema.cpp $(VBSEMA_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBSEMA_PATH)vbsema.cpp

testprog.obj:	testprog.cpp $(TESTPROG_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) testprog.cpp

# Make the executable
OBJECTS = vbthread.obj vbmutex.obj thrpool.obj vthreadt.obj vbcond.obj \
	vbsema.obj thrapiw.obj thelpers.obj testprog.obj
 
$(PROJECT).exe:	$(OBJECTS)
	$(LINKER) $(LINKER_FLAGS) $(OBJECTS) /OUT:$@ 
# ===============================================================

# Remove OBJS, debug files, and executable after running nmake 
# ===============================================================
clean:
	@echo Removing all .SBR files from working directory...
	if exist *.sbr del *.sbr  

	@echo Removing all .VCW files from working directory...
	if exist *.vcw del *.vcw 

	@echo Removing all .PDB files from working directory...
	if exist *.pdb del *.pdb 

	@echo Removing all .WSP files from working directory...
	if exist *.wsp del *.wsp 

	@echo Removing all .BSC files from working directory...
	if exist *.bsc del *.bsc 

	@echo Removing all .SBT files from working directory...
	if exist *.sbt del *.sbt 

	@echo Removing all .ILK files from working directory...
	if exist *.ilk del *.ilk 

	@echo Removing all .IDB files from working directory...
	if exist *.idb del *.idb 

	@echo Removing all .MDP files from working directory...
	if exist *.mdp del *.mdp 

	@echo Removing all .PCH files from working directory...
	if exist *.pch del *.pch 

	@echo Removing all .NCB files from working directory...
	if exist *.ncb del *.ncb 

	@echo Removing all .OBJ files from working directory...
	if exist *.obj del *.obj 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT).exe del $(PROJECT).exe 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################


