// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- // 
// C++ Source Code File Name: testprog.cpp
// Compiler Used: MSVC40, egcs-2.90.29, HP CPP 10.24
// Produced By: Doug Gaer   
// File Creation Date: 03/25/2000
// Date Last Modified: 04/09/2000
// Copyright (c) 2000 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ------------- Program Description and Details ------------- // 
// ----------------------------------------------------------- // 
/*
The VBD and VBS C++ classes are copyright (c) 1997 and 2000 by 
Douglas M. Gaer. All those who put this code or its derivatives 
in a commercial product MUST mention this copyright in their
documentation for users of the products in which this code or its 
derivative classes are used. Otherwise, you have the freedom to 
redistribute verbatim copies of this source code, adapt it to your 
specific needs, or improve the code and release your improvements 
to the public provided that the modified files carry prominent 
notices stating that you changed the files and the date of any
change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

Simple test program demonstrating barrier synchronization
using the VbSemaphore class.
*/
// ----------------------------------------------------------- //   
#include <iostream.h>
#include <stdlib.h>
#include "vbthread.h"
#include "vbsema.h"

// Global semaphore objects
vbSemaphore semaA, semaB;

// Classes derived from the vbThread base class 
class Simple1 : public vbThread
{
private: // Base class interface
  void *ThreadEntryRoutine(vbThread_t *thread);
};

class Simple2 : public vbThread
{
private: // Base class interface
  void *ThreadEntryRoutine(vbThread_t *thread);
};

void *Simple1::ThreadEntryRoutine(vbThread_t *thread)
{
  cout << "Thread 1 here, before the barrier." << endl;
  semaB.SemaphorePost();
  semaA.SemaphoreWait();
  cout << "Thread 1 after the barrier." << endl;
  return 0;
}

void *Simple2::ThreadEntryRoutine(vbThread_t *thread)
{
  cout << "Thread 2 here, before the barrier." << endl;
  semaA.SemaphorePost();
  semaB.SemaphoreWait();
  cout << "Thread 2 after the barrier." << endl;
  return 0;
}

int main()
{
  Simple1 t1;
  Simple2 t2;

  vbThread_t *t1_thread = t1.CreateThread();
  vbThread_t *t2_thread = t2.CreateThread();

  t1.JoinThread(t1_thread);
  t2.JoinThread(t2_thread);

  return 0;
}
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //


  

