#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program  
# C/C++ Compiler Used: Borland C++ 5.5 for Win32
# Produced By: Doug Gaer
# File Creation Date: 05/09/2000
# Date Last Modified: 05/31/2000
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#
# --------------------------------------------------------------- 
!if !$d(BCB)
BCB = $(MAKEDIR)\..
!endif

# Define a name for the executable
PROJECT = testprog

# Setup additional paths for includes and source code
THELPERS_PATH = ../../src/
THRPOOL_PATH = ../../src/
THRAPIW_PATH = ../../src/
VBCOND_PATH = ../../src/
VBMUTEX_PATH = ../../src/
VBSEMA_PATH = ../../src/
VBTHREAD_PATH = ../../src/
VTHREADT_PATH = ../../src/

ADD_INC_PATHS = -I../../include

# Setup define macros
DEFMACS = /D__WIN32__  /D__HAS__BEGINTHREADEX__

# Define macros for compiler and linker
CC = bcc32
CPP = bcc32
LINKER = ilink32

# BCC 32 flags need to build console applications
SYSDEFINES = _NO_VCL
CFLAG1 = -I$(BCB)\include -Od -w -Tkh30000 -r- -a8 -k -y -v -vi- -c -tWM -tWC \
-D$(SYSDEFINES);$(USERDEFINES) 
LFLAG1 = -L$(BCB)\lib;$(DEBUGLIBPATH) -ap -Tpe -x -Gn -v

# Define compiler and linker flags macros
COMPILE_FLAGS= $(CFLAG1) $(ADD_INC_PATHS) $(DEFMACS)
COMPILE_ONLY = /c
LINKER_FLAGS = $(LFLAG1)

# Build dependency rules
# ===============================================================
THELPERS_DEP = ../../include/thrtypes.h ../../include/thelpers.h

THRAPIW_DEP = ../../include/thrtypes.h ../../include/thrapiw.h \
	../../include/vthreadt.h ../../include/vbthread.h \
	../../include/thrpool.h ../../include/vbmutex.h \
	../../include/vbcond.h ../../include/thelpers.h

THRPOOL_DEP = ../../include/thrtypes.h ../../include/thrpool.h \
	../../include/vthreadt.h

VBCOND_DEP = ../../include/thrtypes.h ../../include/vbcond.h \
	../../include/thelpers.h ../../include/vbmutex.h

VBMUTEX_DEP = ../../include/thrtypes.h ../../include/vbmutex.h \
	../../include/thelpers.h

VBSEMA_DEP = ../../include/thrtypes.h ../../include/vbsema.h \
	../../include/thelpers.h

VBTHREAD_DEP = ../../include/thrtypes.h  ../../include/vbthread.h \
	../../include/vthreadt.h ../../include/thrapiw.h \
	../../include/thrpool.h

VTHREADT_DEP = ../../include/thrtypes.h ../../include/vthreadt.h \
	../../include/vbthread.h ../../include/thrpool.h \
	../../include/vbcond.h ../../include/vbmutex.h \
	../../include/thelpers.h

TESTPROG_DEP = ../../include/thrtypes.h ../../include/thelpers.h \
	../../include/vbthread.h ../../include/vthreadt.h \
	../../include/thrpool.h ../../include/vbmutex.h \
	../../include/vbcond.h ../../include/vbsema.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT).exe

thrapiw.obj:	$(THRAPIW_PATH)thrapiw.cpp $(THRAPIW_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(THRAPIW_PATH)thrapiw.cpp

thelpers.obj:	$(THELPERS_PATH)thelpers.cpp $(THELPERS_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(THELPERS_PATH)thelpers.cpp

thrpool.obj:	$(THRPOOL_PATH)thrpool.cpp $(THRPOOL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(THRPOOL_PATH)thrpool.cpp

vbthread.obj:	$(VBTHREAD_PATH)vbthread.cpp $(VBTHREAD_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBTHREAD_PATH)vbthread.cpp

vthreadt.obj:	$(VTHREADT_PATH)vthreadt.cpp $(VTHREADT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VTHREADT_PATH)vthreadt.cpp

vbmutex.obj:	$(VBMUTEX_PATH)vbmutex.cpp $(VBMUTEX_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBMUTEX_PATH)vbmutex.cpp

vbcond.obj:	$(VBCOND_PATH)vbcond.cpp $(VBCOND_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBCOND_PATH)vbcond.cpp

vbsema.obj:	$(VBSEMA_PATH)vbsema.cpp $(VBSEMA_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBSEMA_PATH)vbsema.cpp

testprog.obj:	testprog.cpp $(TESTPROG_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) testprog.cpp

# Make the executable
OBJECTS = vbthread.obj vbmutex.obj thrpool.obj vthreadt.obj vbcond.obj \
	vbsema.obj thrapiw.obj thelpers.obj testprog.obj
 
# BCC 32 libs needed to build console applications
ALLOBJ = c0x32.obj $(OBJECTS)
ALLRES = $(RESFILES)
ALLLIB = $(LIBFILES) import32.lib cw32mt.lib

$(PROJECT).exe:	$(OBJECTS)
	$(LINKER) @&&!
	$(LINKER_FLAGS) +
	$(ALLOBJ), +
	$(PROJECT),, +
	$(ALLLIB), +
	$(DEFFILE), +
	$(ALLRES)
!
# ===============================================================

# Remove OBJS, debug files, and executable after running nmake 
# ===============================================================
clean:
	@echo Removing all .tds files from working directory...
	if exist *.tds del *.tds 

	@echo Removing all .ils files from working directory...
	if exist *.ils del *.ils 

	@echo Removing all .ilf files from working directory...
	if exist *.ilf del *.ilf 

	@echo Removing all .ilc files from working directory...
	if exist *.ilc del *.ilc 

	@echo Removing all .ild files from working directory...
	if exist *.ild del *.ild 

	@echo Removing all .map files from working directory...
	if exist *.map del *.map 

	@echo Removing all .OBJ files from working directory...
	if exist *.obj del *.obj 

	@echo Removing the EXECUTABLE file from working directory
	if exist $(PROJECT).exe del $(PROJECT).exe 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################


