#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the test program
# C/C++ Compiler Used: HP C++ A.10.09  compiled for HP-UX 10.20 
# Produced By: Doug Gaer
# File Creation Date: 03/25/2000
# Date Last Modified: 05/26/2000
# --------------------------------------------------------------- 
# --------------- Makefile Description and Details -------------- 
# --------------------------------------------------------------- 
# Complier Flags 
#       v  -- Echo compilation
#       g  -- Enable debugging
#	+w -- Turn on all warnings
# --------------------------------------------------------------- 
SHELL = /bin/sh

# Define a name for the executable
PROJECT = testprog

# Setup additional paths for includes and source code
THELPERS_PATH = ../../src/
THRPOOL_PATH = ../../src/
THRAPIW_PATH = ../../src/
VBCOND_PATH = ../../src/
VBMUTEX_PATH = ../../src/
VBSEMA_PATH = ../../src/
VBTHREAD_PATH = ../../src/
VTHREADT_PATH = ../../src/

# Setup path to the DCE thread library
DCE_INSTALL_PATH = /opt/dce
DCE_INCLUDE_PATH = $(DCE_INSTALL_PATH)/include
DCE_LIB_PATH = $(DCE_INSTALL_PATH)/lib

ADD_INC_PATHS = -I../../include -I$(DCE_INCLUDE_PATH)

# Setup define macros
DEFMACS = -D__UNIX__ -D__POSIX__ -D__HPUX__ -D__HPUX10__

# Define macros for compiler and linker
CC = cc
CPP = CC
LINKER = ld

# Define compiler and linker flags macros
COMPILE_FLAGS= +DAportable $(ADD_INC_PATHS) $(DEFMACS)

COMPILE_ONLY = -c
OUTPUT = -o
LINKER_FLAGS = 
LIBRARIES = $(DCE_LIB_PATH)/libcma.a 

# Build dependency rules
# ===============================================================
THELPERS_DEP = ../../include/thrtypes.h ../../include/thelpers.h

THRAPIW_DEP = ../../include/thrtypes.h ../../include/thrapiw.h \
	../../include/vthreadt.h ../../include/vbthread.h \
	../../include/thrpool.h ../../include/vbmutex.h \
	../../include/vbcond.h ../../include/thelpers.h

THRPOOL_DEP = ../../include/thrtypes.h ../../include/thrpool.h \
	../../include/vthreadt.h

VBCOND_DEP = ../../include/thrtypes.h ../../include/vbcond.h \
	../../include/thelpers.h ../../include/vbmutex.h

VBMUTEX_DEP = ../../include/thrtypes.h ../../include/vbmutex.h \
	../../include/thelpers.h

VBSEMA_DEP = ../../include/thrtypes.h ../../include/vbsema.h \
	../../include/thelpers.h

VBTHREAD_DEP = ../../include/thrtypes.h  ../../include/vbthread.h \
	../../include/vthreadt.h ../../include/thrapiw.h \
	../../include/thrpool.h

VTHREADT_DEP = ../../include/thrtypes.h ../../include/vthreadt.h \
	../../include/vbthread.h ../../include/thrpool.h \
	../../include/vbcond.h ../../include/vbmutex.h \
	../../include/thelpers.h

CRC32_DEP = crc32.h crc32tab.h

EHANDLER_DEP = ehandler.h

vbINT32_DEP = dtypes.h ehandler.h vbint32.h

VBDFILE_DEP = dtypes.h ehandler.h vbint32.h vbdfile.h refcount.h crc32.h \
	vbuint32.h

vbUINT32_DEP = dtypes.h ehandler.h vbuint32.h

TESTPROG_DEP = dtypes.h ehandler.h vbint32.h vbdfile.h refcount.h vbuint32.h \
	../../include/thrtypes.h ../../include/thelpers.h \
	../../include/vbthread.h ../../include/vthreadt.h \
	../../include/thrpool.h ../../include/vbmutex.h \
	../../include/vbcond.h ../../include/vbsema.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT)

thrapiw.o:	$(THRAPIW_PATH)thrapiw.cpp $(THRAPIW_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(THRAPIW_PATH)thrapiw.cpp

thelpers.o:	$(THELPERS_PATH)thelpers.cpp $(THELPERS_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(THELPERS_PATH)thelpers.cpp

thrpool.o:	$(THRPOOL_PATH)thrpool.cpp $(THRPOOL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(THRPOOL_PATH)thrpool.cpp

vbthread.o:	$(VBTHREAD_PATH)vbthread.cpp $(VBTHREAD_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBTHREAD_PATH)vbthread.cpp

vthreadt.o:	$(VTHREADT_PATH)vthreadt.cpp $(VTHREADT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VTHREADT_PATH)vthreadt.cpp

vbmutex.o:	$(VBMUTEX_PATH)vbmutex.cpp $(VBMUTEX_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBMUTEX_PATH)vbmutex.cpp

vbcond.o:	$(VBCOND_PATH)vbcond.cpp $(VBCOND_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBCOND_PATH)vbcond.cpp

vbsema.o:	$(VBSEMA_PATH)vbsema.cpp $(VBSEMA_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBSEMA_PATH)vbsema.cpp


ehandler.o:	$(EHANDLER_PATH)ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(EHANDLER_PATH)ehandler.cpp

vbint32.o:	$(DTYPES_PATH)vbint32.cpp $(vbINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(DTYPES_PATH)vbint32.cpp

vbdfile.o:    $(VBDFILE_PATH)vbdfile.cpp $(VBDFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(VBDFILE_PATH)vbdfile.cpp

vbuint32.o:	$(DTYPES_PATH)vbuint32.cpp $(vbUINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(DTYPES_PATH)vbuint32.cpp

crc32.o:	$(CRC32_PATH)crc32.cpp $(CRC32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(CRC32_PATH)crc32.cpp

testprog.o:	testprog.cpp $(TESTPROG_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) testprog.cpp

# Make the executable
OBJECTS = vbthread.o vbmutex.o thrpool.o vthreadt.o vbcond.o \
	vbsema.o thrapiw.o thelpers.o ehandler.o vbint32.o \
	testprog.o crc32.o vbuint32.o vbdfile.o 

$(PROJECT):	$(OBJECTS)
	$(CPP) $(COMPILE_FLAGS) $(OBJECTS) $(LIBRARIES) \
	$(OUTPUT) $(PROJECT) $(LINKER_FLAGS)
# ===============================================================

# Remove object files and the executable after running make 
# ===============================================================
clean:
	echo Removing all OBJECT files from working directory...
	rm -f *.o 

	echo Removing EXECUTABLE file from working directory...
	rm -f $(PROJECT)

	echo Removing all test files from working directory...
	rm -f *.vbd 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################
