// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: thrapiw.h
// Compiler Used: MSVC40, egcs-2.90.29, HP CPP 10.24
// Produced By: Doug Gaer   
// File Creation Date: 03/25/2000
// Date Last Modified: 05/30/2000
// Copyright (c) 2000 Douglas M. Gaer
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
The VBD and VBS C++ classes are copyright (c) 1997 and 2000 by 
Douglas M. Gaer. All those who put this code or its derivatives 
in a commercial product MUST mention this copyright in their
documentation for users of the products in which this code or its 
derivative classes are used. Otherwise, you have the freedom to 
redistribute verbatim copies of this source code, adapt it to your 
specific needs, or improve the code and release your improvements 
to the public provided that the modified files carry prominent 
notices stating that you changed the files and the date of any
change.

THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

The vbThreadAPIWrapper class is used to call native thread API 
functions for each specified platform. NOTE: This class is not 
intended to be used directly by an application or a derived 
class. It is used by the vbThread base class to call the correct 
native thread API function for each of the supported platforms.
*/
// ----------------------------------------------------------- //   
#ifndef __VBTHREAD_API_WRAPPER_HPP__
#define __VBTHREAD_API_WRAPPER_HPP__

#include "thrtypes.h"

// Foward class calling conventions
class vbThread_t; // Thread class used to store thread variables
class vbThread;   // Base class used to create threaded objects 

class vbThreadAPIWrapper
{
public:
  vbThreadAPIWrapper() { }   
  ~vbThreadAPIWrapper() { }

private: // Disallow copying and assignment
  vbThreadAPIWrapper(const vbThreadAPIWrapper &ob) { }
  void operator=(const vbThreadAPIWrapper &ob) { }

public: // Native thread API functions
  int apiInitThreadAttribute(vbThreadAttribute *attr);
  int apiDestroyThreadAttribute(vbThreadAttribute *attr);
  int apiCreateThread(vbThread_t *thread);
  int apiJoinThread(vbThread_t *thread);
  int apiSuspendThread(vbThread_t *thread);
  int apiResumeThread(vbThread_t *thread);
  int apiCancelThread(vbThread_t *thread);
  int apiCloseThread(vbThread_t *thread);
  int apiDestroyThread(vbThread_t *thread, int check_state = 1);
  void *apiExitThread(vbThread_t *thread, int exit_code);
  int apiSetThreadPriority(vbThread_t *thread);
  int apiThreadKeyCreate(vbThreadKey &key);
  int apiThreadKeyDelete(vbThreadKey &key);
  int apiThreadSetSpecific(vbThreadKey &key, const void *value);
  void *apiThreadGetSpecific(vbThreadKey &key);

public: // Timer functions
  void api_mSleep(int milliseconds);
  void api_sSleep(int seconds);

public: // Cross-platform thread entry points
#if defined (__WIN32__)
  // NOTE: The *arg pointer will be cast to vbThread_t type
  static DWORD apiThreadStartRoutine(void *arg);
#elif defined (__POSIX__)
  // NOTE: The *arg pointer will be cast to vbThread_t type
  static void *apiThreadStartRoutine(void *arg);
#else
#error You must define an API: __WIN32__ or __POSIX__
#endif

public: // Thread cleanup handler
  // NOTE: The *arg pointer will be cast to vbThread_t type
  static void apiThreadCleanupHandler(void *arg);
};

#endif // __VBTHREAD_API_WRAPPER_HPP__
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
